import re
import struct
import glob
import pprint

fn_re = re.compile('(\w+)-(\d+)-.*\.blocks');

blocks = {}

for fn in glob.iglob('*.blocks'):
  mo = fn_re.match(fn)
  if mo is None:
    print 'Skipping \'%s\'' % fn
    continue
  dep_name = mo.groups(1)[0]
  dep_number = mo.groups(2)[0]
  
  f = open(fn, 'rb')
  dep_blocks = set()

  def read32le(f):
    buff = f.read(4)
    if buff  == '':
      return None
    return struct.unpack('<I', buff)[0]
  
  endian = read32le(f)
  low = read32le(f)
  high = read32le(f)
  while 1:
    addr = read32le(f)
    if addr is None:
      break

    dep_blocks.add(addr - low)

  if dep_name not in blocks:
    blocks[dep_name] = dep_blocks
  else:
    blocks[dep_name] = blocks[dep_name] & dep_blocks
  f.close()

uniqs = {}
for dep in blocks:
  uniq = blocks[dep]
  for other_dep in blocks:
    if other_dep != dep:
      uniq = uniq - blocks[other_dep]
  uniqs[dep] = uniq

for dep in uniqs:
  f = open('%s-results.blocks' % dep,'w')
  sblocks = list(uniqs[dep])
  sblocks.sort()
  for block in sblocks:
    print >> f, '%08x' % block
  f.close()

